// C Source File
// Created 25/07/2003; 07:59:51
// Linux TI89 kernel
// v1.1.0 beta
// It includes all the main functions of Linux TI89
//Limmt Ribeman (c) 2004
//limmt@wanadoo.fr

#define RETURN_VALUE kr       // Return Pushed Expression

//#define USE_KERNEL						// Use kernel

#define OPTIMIZE_ROM_CALLS		// Use ROM Call Optimization

#define MIN_AMS 200           // Compile for AMS 2.00 or higher

#include <tigcclib.h>         // Include All Header Files
#include "kernel.h"						// Include kernel header file

// Main Function
void _main(void)
{
	unsigned long nbc=0;
	unsigned long p=0;
	const char *nom;
	char *pass;
	ESI argptr;
	InitArgPtr(argptr);
	char *arg;
	char *tmp=malloc(20);
	*tmp=0;
  arg = (char*)GetStrnArg (argptr);
	if(strcmp(arg, "version") == 0 || strcmp(arg, "ci") == 0)
	{
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("1.1.0");
		push_ANSI_string("v");
		push_ANSI_string("Version");
	}
	else if(strcmp(arg, "start") == 0)
	{
		if(FolderAdd($(temp))==H_NULL)
		{
			while (ESTACK (top_estack) != END_TAG)
			top_estack = next_expression_index (top_estack);
			top_estack--;
			push_END_TAG();
			push_ANSI_string("temp directory already exists");
			push_ANSI_string("er");
			push_ANSI_string("[ERROR]");
		}
		FolderCur($(temp),FALSE);
		expr_create(1, "temp\\started");
		str_create("", "temp\\fc");
		str_create("localhost", "l_etc\\hostname");
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("Kernel started correctly");
		push_ANSI_string("sc");
		push_ANSI_string("[ OK ]");
	}
	else if(strcmp(arg, "shutdown") == 0)
	{
		FolderDel($(temp));
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("Kernel stopped correctly");
		push_ANSI_string("sc");
		push_ANSI_string("[ OK ]");
	}
	else if(strcmp(arg, "ls") == 0)
	{
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
	if(strcmp(getstr((char *)"temp\\fc"), "") == 0)
  {
  SYM_ENTRY *SymPtr = SymFindFirst(NULL,4);
    while(SymPtr)
      {
        push_ANSI_string(SymPtr->name);
        SymPtr = SymFindNext();
      }
  }
	else
  {
  SYM_ENTRY *SymPtr = SymFindFirst(SYMSTR(getstr((char *)"temp\\fc")), 1);
  while(SymPtr)
    {
      push_ANSI_string(SymPtr->name);
      SymPtr = SymFindNext();
    }
  }
	}
	else if(strncmp(arg, "connect ", 8) == 0)
	{
		p=strcspn (arg+8, ":");
		nbc=getexpr((char *)"l_etc\\nbuser");
		nom=getstr((char *)"l_etc\\us0");
		if(strncmp(arg+8, nom, p-1) == 0)
		{
			pass=getstr((char *)"l_etc\\pass0");
			strcp=pass;
			pass=decrypt(pass);
			//if(strcmp(arg+8+p, pass) == 0)
			//{
			expr_create(0,"temp\\login");
			push_END_TAG();
			push_ANSI_string(nom);
			push_ANSI_string("Connected as");
			push_ANSI_string("co");
			push_ANSI_string("Connection OK");
			goto fin;
			//}
		}
		if(nbc>=1)
		{
			nom=getstr((char *)"l_etc\\us1");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass1");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(1,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=2)
		{
			nom=getstr((char *)"l_etc\\us2");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass2");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(2,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=3)
		{
			nom=getstr((char *)"l_etc\\us3");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass3");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(3,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=4)
		{
			nom=getstr((char *)"l_etc\\us4");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass4");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(4,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=5)
		{
			nom=getstr((char *)"l_etc\\us5");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass5");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(5,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=6)
		{
			nom=getstr((char *)"l_etc\\us6");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass6");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(6,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=7)
		{
			nom=getstr((char *)"l_etc\\us7");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass7");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(7,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=8)
		{
			nom=getstr((char *)"l_etc\\us8");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass8");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(8,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		if(nbc>=9)
		{
			nom=getstr((char *)"l_etc\\us9");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr((char *)"l_etc\\pass9");
				strcp=pass;
				pass=decrypt(pass);
				//if(strcmp(arg+8+p, pass) == 0)
				//{
				expr_create(9,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				//}
			}
		}
		push_END_TAG();
		push_ANSI_string("Login or password did not match.");
		push_ANSI_string("cf");
		push_ANSI_string("Connection falided");
	}
	else if(strncmp(arg, "mrd ", 4) == 0)
	{
		FolderDel(SYMSTR(arg+4));
		push_END_TAG();
		push_ANSI_string(arg+4);
		push_ANSI_string("fd");
		push_ANSI_string("Folder deleted");
	}
	else if(strncmp(arg, "cp ", 3) == 0)
	{
		memset(tmp,0,20);
		strncpy(tmp,arg+3,strcspn (arg+3, ":"));
		copy(arg+3+p, tmp);
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strncmp(arg, "copy ", 5) == 0)
	{
		memset(tmp,0,20);
		strncpy(tmp,arg+5,strcspn (arg+3, ":"));
		copy(arg+5+p, tmp);
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strncmp(arg, "cd ", 3) == 0)
	{
		if(arg+3=="..")
		{
			str_create("", "temp\\fc");
		}
		else
		{
			str_create(arg+3, "temp\\fc");
		}
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strncmp(arg, "chroot ", 7) == 0)
	{
		if(arg+7=="..")
		{
			str_create("", "temp\\fc");
		}
		else
		{
			str_create(arg+7, "temp\\fc");
		}
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strcmp(arg, "getfold") == 0)
	{
		push_END_TAG();
		push_ANSI_string(getstr((char *)"temp\\fc"));
	}
	else if(strncmp(arg, "echo ", 5) == 0)
	{
		push_END_TAG();
		push_ANSI_string(arg+5);
	}
	else if(strcmp(arg, "hostname") == 0)
	{
		push_END_TAG();
		push_ANSI_string(getstr((char *)"l_etc\\hostname"));
	}
	else if(strcmp(arg, "hwclock") == 0)
	{
		push_END_TAG();
		push_ANSI_string("Error: This function is not active yet.");
	}
	
	else if(strcmp(arg, "logname") == 0)
	{
		push_END_TAG();
		push_ANSI_string("root");
	}
	else if(strncmp(arg, "mcd ", 4) == 0)
	{
		FolderCur($(arg+4),FALSE);
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strncmp(arg, "mdel ", 5) == 0)
	{
		SymDel($(arg+5));
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strncmp(arg, "mkdir ", 6) == 0)
	{
		FolderAdd($(arg+6));
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strncmp(arg, "mmd ", 4) == 0)
	{
		FolderAdd($(arg+4));
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strcmp(arg, "netstat") == 0)
	{
		push_END_TAG();
		push_ANSI_string("State: Listening");
		push_ANSI_string("Speed: 68000 bps");
		push_ANSI_string("Link: Port Jack 2.5");
	}
	else if(strncmp(arg, "rmdir ", 6) == 0)
	{
		FolderDel(SYMSTR(arg+6));
		push_END_TAG();
		push_ANSI_string(arg+6);
		push_ANSI_string("fd");
		push_ANSI_string("Folder deleted");
	}
	else if(strncmp(arg, "rm ", 3) == 0)
	{
		SymDel($(arg+3));
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strcmp(arg, "rusers") == 0)
	{
		push_END_TAG();
		push_ANSI_string("root");
	}
	else if(strncmp(arg, "sleep ", 6) == 0)
	{
		wait(atoi (arg+6));
		push_END_TAG();
		push_ANSI_string("Ok");
	}
	else if(strcmp(arg, "who") == 0)
	{
		push_END_TAG();
		push_ANSI_string("root");
	}
	else if(strcmp(arg, "uname") == 0)
	{
		push_END_TAG();
		if(AB_getGateArrayVersion () == 1)
		{
			push_ANSI_string("HW1 - 10Mhz");
		}
		else if(AB_getGateArrayVersion () == 2)
		{
			push_ANSI_string("HW2 - 12Mhz");
		}
		else
		{
			push_ANSI_string("HW? - ??Mhz");
		}
		push_ANSI_string("TI89");
	}
	fin:;
	HeapFreePtr(tmp);
	push_LIST_TAG();
}
